


#include "ppdgem.h"
#include "vmcolour.h"
#define MAINDEF
#include "colours.h"
#undef MAINDEF
#include <stdio.h>

extern LPWORD ad_rmsg;
extern WORD gl_rmsg[];
extern WORD hndl_mesag();
extern WORD hello_whndl;
extern WORD vdi_handle;
extern GRECT work_area;			/* current window work area	*/

char *id[MAXC] = {
              "Active title",
		  	  "Inactive title",
              "Info bar",
              "Desk",
              "Slider",
              "Button",
              "Alert"
			};


int idno[MAXC] = {
			  VMAX_ATITLE,
			  VMAX_ITITLE,
			  VMAX_INFO,
			  VMAX_DESK,
			  VMAX_SLIDER,
			  VMAX_BUTTON,
			  VMAX_ALERT
			};

WORD cur_id = 0;
			
/* Note: If we dump VIEWMAX.INI and use our own colour storage system, 
 *      then we can also set the colour sets that ViewMAX doesn't use.
 *
 *      We would then have to swallow xgrf_colour() calls from the ViewMAX
 *      desktop. 
 */
			
PPDUBLK col_ublk[16];
PPDUBLK id_ublk[16];
PPDUBLK stl_ublk[4];
PPDUBLK idx_ublk[24];
PPDUBLK pre_ublk[7];
PPDUBLK scheme_ublk[11];

extern WORD work_out[];

VOID filled_rect(GRECT *area, WORD fg, WORD bg, WORD style, WORD index);

VOID paint_desk(VOID)
{
	GRECT rc;

	rc.g_x = rc.g_y = 0;
	rc.g_w = work_out[0] + 2;
	rc.g_h = work_out[1] + 2;

#ifndef DESKACC
	filled_rect(&rc, cur_col[10].fg, cur_col[10].bg, cur_col[10].fs, cur_col[10].fi);	
#endif
}

VOID set_colours(VOID)
{
	WORD n;

	for (n = 0; n < MAXC; n++)
	{
		xgrf_colour(idno[n], cur_col[idno[n]].fg, cur_col[idno[n]].bg, 
		                     cur_col[idno[n]].fs, cur_col[idno[n]].fi);
	}
}


VOID grect_to_array(GRECT *area, WORD *array);
VOID set_clip(WORD clip_flag, GRECT *s_area);	/* set clip to specified area		*/



WORD contrast(WORD col)
{
	if (col == 0 || col == 3 || col == 5 || col == 6) return BLACK;
	return WHITE;
}


VOID draw_rect(GRECT *area)	/* Draw a rectangle round an area */
{
   	WORD	pxy[10];

   	pxy[0] = area->g_x;
   	pxy[1] = area->g_y;
   	pxy[2] = area->g_x + area->g_w - 1;
   	pxy[3] = area->g_y + area->g_h - 1;
   	pxy[4] = pxy[2];
   	pxy[5] = pxy[3];
   	pxy[3] = pxy[1];
  	pxy[6] = pxy[0];
   	pxy[7] = pxy[5];
   	pxy[8] = pxy[0];
   	pxy[9] = pxy[1];
   	v_pline(vdi_handle, 5, pxy);
}


VOID filled_rect(GRECT *area, WORD fg, WORD bg, WORD style, WORD index)
{
	WORD pxy[8];
	
   	pxy[0] = area->g_x;
   	pxy[1] = area->g_y;
   	pxy[2] = area->g_x + area->g_w - 1;
   	pxy[3] = area->g_y + area->g_h - 1;
   	pxy[4] = pxy[2];
   	pxy[5] = pxy[3];
   	pxy[3] = pxy[1];
   	pxy[6] = pxy[0];
   	pxy[7] = pxy[5];

   	vswr_mode   (vdi_handle, 1);
	vsf_interior(vdi_handle, 1);
	vsf_style(   vdi_handle, 1);
	vsf_color(   vdi_handle, bg);
	v_fillarea(  vdi_handle, 4, pxy);

	vswr_mode   (vdi_handle, 2);
	vsf_interior(vdi_handle, style);
	vsf_style(   vdi_handle, index);
	vsf_color(   vdi_handle, fg);
	v_fillarea(  vdi_handle, 4, pxy);

}




WORD find_obj(LPTREE tree, WORD start_obj, WORD which)       
							   /* routine to find the next editable */
					           /* text field, or a field that is as */
						       /* marked as a default return field. */
{
	REG WORD	obj, flag, theflag, inc;

	obj = 0;
	flag = EDITABLE;
	inc = 1;
	switch(which)
	{
	  case FMD_BACKWARD:
		inc = -1;
						/* fall thru		*/
	  case FMD_FORWARD:
		obj = start_obj + inc;
		break;
	  case FMD_DEFLT:
		flag = DEFAULT;
		break;
	}

	while ( obj >= 0 )
	{
	  theflag = tree[obj].ob_flags;
	  if (theflag & flag)
	    return(obj);
	  if (theflag & LASTOB)
	    obj = -1;
	  else
	    obj += inc;
	}
	return(start_obj);
}


WORD fm_inifld(LPTREE tree, WORD start_fld)
{
						/* position cursor on	*/
						/*   the starting field	*/
	if (start_fld == 0)
	  start_fld = find_obj(tree, 0, FMD_FORWARD);
	return( start_fld );
}


WORD c1_form_do(LPTREE tree, WORD start_fld, WORD *msg_stop)
{
	REG WORD	edit_obj;
	WORD		next_obj;
	WORD		which, cont;
	WORD		idx;
	UWORD		mx, my, mb, ks, kr, br;
	
	wind_update(1);
	wind_update(3);
						/* set starting field	*/
						/*   to edit, if want	*/
						/*   first editing field*/
						/*   then walk tree	*/
	next_obj = fm_inifld(tree, start_fld);
	edit_obj = 0;
						/* interact with user	*/
	cont     = TRUE;
	*msg_stop = FALSE;
	while(cont)
	{
						/* position cursor on	*/
						/*   the selected 	*/
						/*   editting field	*/
	  if ( (next_obj != 0) &&
	       (edit_obj != next_obj) )
	  {
	    edit_obj = next_obj;
	    next_obj = 0;
	    objc_edit(tree, edit_obj, 0, &idx, EDINIT);
	  }
						/* wait for mouse or key */
	  which = evnt_multi(MU_KEYBD | MU_BUTTON | MU_MESAG, 
			0x02, 0x01, 0x01, 
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			ad_rmsg,
			0, 0,
			&mx, &my, &mb, &ks, &kr, &br);

						/* handle keyboard event*/
	  if (which & MU_MESAG)
	  {
			wind_update(BEG_UPDATE);	/* begin window update	*/
			*msg_stop = hndl_mesag();
			wind_update(END_UPDATE);	/* end window update	*/
		  
			cont = !(*msg_stop);
	  }
	  else if (which & MU_KEYBD)
	  {
	    cont = form_keybd(tree, edit_obj, next_obj, kr, &next_obj, (WORD *)&kr);
	    if (kr)
	      objc_edit(tree, edit_obj, kr, &idx, EDCHAR);
	  }
						/* handle button event	*/
	  else if (which & MU_BUTTON)
	  {
	    next_obj = objc_find(tree, ROOT, MAX_DEPTH, mx, my);
 	    if (next_obj == NIL)
	    {
	      /* sound(TRUE, 440, 2); */
	      next_obj = 0;
	      cont = 0;	/* [JCE] click outside the tree - return 0 */
	    }
	    else
	      cont = form_button(tree, next_obj, br, &next_obj);
	  }
						/* handle end of field	*/
						/*   clean up		*/
	  if ( (!cont) ||
	       ((next_obj != 0) && 
		(next_obj != edit_obj)) )

	  {
	    objc_edit(tree, edit_obj, 0, &idx, EDEND);
	  }
	}

	wind_update(2);
	wind_update(0);
						/* return exit object	*/
						/*   hi bit may be set	*/
						/*   if exit obj. was	*/
						/*   double-clicked	*/
	return(next_obj);
}





WORD paint_all(LPPARM lp)
{
	PARMBLK pb;
	COLDEF far *ptr;
	
	LBCOPY((LPBYTE)ADDR(&pb), (LPBYTE)lp ,sizeof(PARMBLK));

    set_clip(TRUE, (GRECT *) &pb.pb_xc);

    ptr = (COLDEF far *)pb.pb_parm;
    
	filled_rect((GRECT *)(&pb.pb_x), ptr->fg, ptr->bg, ptr->fs, ptr->fi);

	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, BLACK);
	draw_rect((GRECT *) &pb.pb_x);
	
	set_clip(FALSE, (GRECT *) &work_area);

	return 0;
}



WORD paint_scheme(LPPARM lp)
{
	PARMBLK pb;
	WORD	pid;
	COLDEF  *ptr;
	char str[30];

	LBCOPY((LPBYTE)ADDR(&pb), (LPBYTE)lp ,sizeof(PARMBLK));
	
    set_clip(TRUE, (GRECT *) &pb.pb_xc);

    pid = (WORD)pb.pb_parm;
	ptr = &(cur_col[idno[pid]]); 
    
	filled_rect((GRECT *)(&pb.pb_x), WHITE, WHITE, 1, 1);

	sprintf(str, "%-16.16s", csid[pid]);

	vswr_mode(vdi_handle, 2);
	vst_color(vdi_handle, BLACK);
	v_gtext(vdi_handle, pb.pb_x + 1, pb.pb_y + pb.pb_h - 2, str);
	if (pb.pb_currstate & SELECTED)
		{
		vswr_mode(vdi_handle, 2);
		vst_color(vdi_handle, 0x2);
		v_gtext(vdi_handle, pb.pb_x + 1, pb.pb_y + pb.pb_h - 2, str);
		}

	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, BLACK);
	--pb.pb_y;
	++pb.pb_h;
	draw_rect((GRECT *) &pb.pb_x);
	
	set_clip(FALSE, (GRECT *) &work_area);
	
	return 0;
}



WORD paint_id(LPPARM lp)
{
	PARMBLK pb;
	WORD	pid;
	COLDEF  *ptr;
	char str[30];
	GRECT   rc;

	LBCOPY((LPBYTE)ADDR(&pb), (LPBYTE)lp ,sizeof(PARMBLK));
	
    set_clip(TRUE, (GRECT *) &pb.pb_xc);

    pid = (WORD)pb.pb_parm;
	ptr = &(cur_col[idno[pid]]); 
    
	filled_rect((GRECT *)(&pb.pb_x), WHITE, WHITE, 1, 1);
	rc.g_x  = pb.pb_x + pb.pb_w - 64;
	rc.g_y  = pb.pb_y + 1;
	rc.g_w  = 63;
	rc.g_h  = pb.pb_h - 2;
	filled_rect(&rc, ptr->fg, ptr->bg, ptr->fs, ptr->fi);

	sprintf(str, "%-16.16s", id[pid]);

	vswr_mode(vdi_handle, 2);
	vst_color(vdi_handle, BLACK);
	v_gtext(vdi_handle, pb.pb_x + 1, pb.pb_y + pb.pb_h - 2, str);
	if (pb.pb_currstate & SELECTED)
		{
		vswr_mode(vdi_handle, 2);
		vst_color(vdi_handle, 0x2);
		v_gtext(vdi_handle, pb.pb_x + 1, pb.pb_y + pb.pb_h - 2, str);
		}

	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, BLACK);
	--pb.pb_y;
	++pb.pb_h;
	draw_rect((GRECT *) &pb.pb_x);
	
	set_clip(FALSE, (GRECT *) &work_area);
	
	return 0;
}





WORD paint_style(LPPARM lp)
{
	PARMBLK pb;
	WORD style;
	WORD dotext;

	char str[3];
	LBCOPY((LPBYTE)ADDR(&pb), (LPBYTE)lp ,sizeof(PARMBLK));

    set_clip(TRUE, (GRECT *) &pb.pb_xc);

    style  =  (WORD)pb.pb_parm & 0xFFFF;
	dotext = ((LONG)pb.pb_parm & 0x10000L) ? 1 : 0;
    
	filled_rect((GRECT *)(&pb.pb_x), BLACK, WHITE, style, 3);

	if (pb.pb_currstate & SELECTED)
		{
	  	vsl_color(vdi_handle, 3);
		vsl_width(vdi_handle, 2);
		vsl_type(vdi_handle, FIS_SOLID);

		pb.pb_x+=2;
		pb.pb_y+=2;
		pb.pb_w-=4;
		pb.pb_h-=4;
		draw_rect((GRECT *) &pb.pb_x);
		pb.pb_x-=2;
		pb.pb_y-=2;
		pb.pb_w+=4;
		pb.pb_h+=4;
	}  
	if (dotext)
	{
		sprintf(str, "%d", style);

		vswr_mode(vdi_handle, 1);
		vst_color(vdi_handle, BLACK);
		v_gtext(vdi_handle, pb.pb_x + (pb.pb_w/4), pb.pb_y + (pb.pb_h/2), str);
	}
	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, BLACK);
	draw_rect((GRECT *) &pb.pb_x);
	
	set_clip(FALSE, (GRECT *) &work_area);

	return 0;
}


WORD paint_index(LPPARM lp)
{
	PARMBLK pb;
	WORD index;
	WORD dotext;

	char str[3];
	LBCOPY((LPBYTE)ADDR(&pb), (LPBYTE)lp ,sizeof(PARMBLK));

    set_clip(TRUE, (GRECT *) &pb.pb_xc);

    index  =  (WORD)pb.pb_parm & 0xFFFF;
	dotext = ((LONG)pb.pb_parm & 0x10000L) ? 1 : 0;
    
	filled_rect((GRECT *)(&pb.pb_x), BLACK, WHITE, cur_col[idno[cur_id]].fs, index);
    
	if (pb.pb_currstate & SELECTED)
		{
	  	vsl_color(vdi_handle, 3);
		vsl_width(vdi_handle, 2);
		vsl_type(vdi_handle, FIS_SOLID);

		pb.pb_x+=2;
		pb.pb_y+=2;
		pb.pb_w-=4;
		pb.pb_h-=4;
		draw_rect((GRECT *) &pb.pb_x);
		pb.pb_x-=2;
		pb.pb_y-=2;
		pb.pb_w+=4;
		pb.pb_h+=4;
	}  
	if (dotext)
	{
		sprintf(str, "%d", index);

		vswr_mode(vdi_handle, 1);
		vst_color(vdi_handle, BLACK);
		v_gtext(vdi_handle, pb.pb_x + (pb.pb_w/4), pb.pb_y + (pb.pb_h/2), str);
	}
	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, BLACK);
	draw_rect((GRECT *) &pb.pb_x);
		
	set_clip(FALSE, (GRECT *) &work_area);

	return 0;
}



WORD paint_colour(LPPARM lp)
{
	PARMBLK pb;
	WORD col;
	WORD dotext;

	char str[3];
	LBCOPY((LPBYTE)ADDR(&pb), (LPBYTE)lp ,sizeof(PARMBLK));

    set_clip(TRUE, (GRECT *) &pb.pb_xc);

    col    =  (WORD)pb.pb_parm & 0xFFFF;
	dotext = ((LONG)pb.pb_parm & 0x10000L) ? 1 : 0;
    
	filled_rect((GRECT *)(&pb.pb_x), col, col, 1, 1);
    
	if((pb.pb_currstate != pb.pb_prevstate) ||
	   (pb.pb_currstate &  SELECTED))
	{   	
		if (pb.pb_currstate & SELECTED)
			{
		  	vsl_color(vdi_handle, contrast(col));
			}
		else
			{
		  	vsl_color(vdi_handle, col);
			}
		vsl_width(vdi_handle, 2);
		vsl_type(vdi_handle, FIS_SOLID);

		pb.pb_x+=2;
		pb.pb_y+=2;
		pb.pb_w-=4;
		pb.pb_h-=4;
		draw_rect((GRECT *) &pb.pb_x);
		pb.pb_x-=2;
		pb.pb_y-=2;
		pb.pb_w+=4;
		pb.pb_h+=4;
	}  
	if (dotext)
	{
		sprintf(str, "%d", col);

		vswr_mode(vdi_handle, 2);
		vst_color(vdi_handle, contrast(col));
		v_gtext(vdi_handle, pb.pb_x + (pb.pb_w/4), pb.pb_y + (pb.pb_h/2), str);
	}
	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, BLACK);
	draw_rect((GRECT *) &pb.pb_x);
		
	set_clip(FALSE, (GRECT *) &work_area);

	return 0;
}


WORD get_colour(WORD *clr, LPTREE tree, WORD obj)
{
	LPTREE tr;
//	WORD editing = 1;
	WORD n;
	WORD msg_stop;
	WORD obx, oby;
	
	rsrc_gaddr(R_TREE, DDCOLOUR, (LPVOID *)&tr);

	objc_offset(tree, obj, &obx, &oby);
	
	tr[ROOT].ob_x = obx + tree[obj].ob_width - tr[ROOT].ob_width;
	tr[ROOT].ob_y = oby + tree[obj].ob_height;

	for (n = 0; n < 16; n++)
	{
		tr[n + 1].ob_state &= ~SELECTED;
		tr[n + 1].ob_flags |= SELECTABLE | TOUCHEXIT; 

		col_ublk[n].ub_parm = 0x10000L | n;
		col_ublk[n].ub_code = paint_colour;
		ppd_userdef(tr, n+1, &col_ublk[n]);
	}
	tr[*clr + 1].ob_state |= SELECTED;

	form_dial(0,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (zoom) form_dial(1,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	 
	objc_draw(tr, ROOT, MAX_DEPTH, tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	
	n = (c1_form_do(tr, 0, &msg_stop)) & 0x7FFF;

	if (zoom) form_dial(2,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);


	form_dial(3,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (n > 0) *clr = n - 1;

	return msg_stop;
}




WORD get_scheme(WORD *pid, LPTREE tree, WORD obj)
{
	LPTREE tr;
	WORD n;
	WORD msg_stop;
	WORD obx, oby;
	
	rsrc_gaddr(R_TREE, DDSCHEM, (LPVOID *)&tr);

	objc_offset(tree, obj, &obx, &oby);
	
	tr[ROOT].ob_x = obx + tree[obj].ob_width - tr[ROOT].ob_width;
	tr[ROOT].ob_y = oby + tree[obj].ob_height;

	for (n = 0; n < 10; n++)
	{
		tr[n + 1].ob_state &= ~SELECTED;
		tr[n + 1].ob_flags |= SELECTABLE | TOUCHEXIT; 

		scheme_ublk[n].ub_parm = n;
		scheme_ublk[n].ub_code = paint_scheme;
		ppd_userdef(tr, n+1, &scheme_ublk[n]);
	}
	tr[*pid + 1].ob_state |= SELECTED;

	form_dial(0,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (zoom) form_dial(1,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	 
	objc_draw(tr, ROOT, MAX_DEPTH, tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	
	n = (c1_form_do(tr, 0, &msg_stop)) & 0x7FFF;

	if (zoom) form_dial(2,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);


	form_dial(3,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (n > 0) *pid = n - 1;

	return msg_stop;
}



WORD get_id(WORD *pid, LPTREE tree, WORD obj)
{
	LPTREE tr;
	WORD n;
	WORD msg_stop;
	WORD obx, oby;
	
	rsrc_gaddr(R_TREE, DDITEMS, (LPVOID *)&tr);

	objc_offset(tree, obj, &obx, &oby);
	
	tr[ROOT].ob_x = obx + tree[obj].ob_width - tr[ROOT].ob_width;
	tr[ROOT].ob_y = oby + tree[obj].ob_height;

	for (n = 0; n < MAXC; n++)
	{
		tr[n + 1].ob_state &= ~SELECTED;
		tr[n + 1].ob_flags |= SELECTABLE | TOUCHEXIT; 

		id_ublk[n].ub_parm = n;
		id_ublk[n].ub_code = paint_id;
		ppd_userdef(tr, n+1, &id_ublk[n]);
	}
	tr[*pid + 1].ob_state |= SELECTED;

	form_dial(0,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

// "zoom" effects omitted. Combo boxes don't zoom, and it wastes time.

	if (zoom) form_dial(1,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	 
	objc_draw(tr, ROOT, MAX_DEPTH, tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	
	n = (c1_form_do(tr, 0, &msg_stop)) & 0x7FFF;

	if (zoom) form_dial(2,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);


	form_dial(3,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (n > 0) *pid = n - 1;

	return msg_stop;
}



WORD get_style(WORD *stl, LPTREE tree, WORD obj)
{
	LPTREE tr;
	WORD n;
	WORD msg_stop;
	WORD obx, oby;
	
	rsrc_gaddr(R_TREE, DDSTYLE, (LPVOID *)&tr);

	objc_offset(tree, obj, &obx, &oby);
	
	tr[ROOT].ob_x = obx + tree[obj].ob_width - tr[ROOT].ob_width;
	tr[ROOT].ob_y = oby + tree[obj].ob_height;

	for (n = 0; n < 4; n++)
	{
		tr[n + 1].ob_state &= ~SELECTED;
		tr[n + 1].ob_flags |= SELECTABLE | TOUCHEXIT; 

		stl_ublk[n].ub_parm = 0x10000L | n;
		stl_ublk[n].ub_code = paint_style;
		ppd_userdef(tr, n+1, &stl_ublk[n]);
	}
	tr[*stl + 1].ob_state |= SELECTED;

	form_dial(0,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (zoom) form_dial(1,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	 
	objc_draw(tr, ROOT, MAX_DEPTH, tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	
	n = (c1_form_do(tr, 0, &msg_stop)) & 0x7FFF;

	if (zoom) form_dial(2,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);


	form_dial(3,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (n > 0) *stl = n - 1;

	return msg_stop;
}




WORD get_index(WORD *idx, LPTREE tree, WORD obj)
{
	LPTREE tr;
	WORD n;
	WORD msg_stop;
	WORD obx, oby;
	WORD maxn;

	if (cur_col[idno[cur_id]].fs == 3) 
	{
		maxn = 12;
		rsrc_gaddr(R_TREE, DDHATCH, (LPVOID *)&tr);
	}
	else
	{
		maxn = 24;
		rsrc_gaddr(R_TREE, DDINDEX, (LPVOID *)&tr);
	}
	
	objc_offset(tree, obj, &obx, &oby);
	
	tr[ROOT].ob_x = obx + tree[obj].ob_width - tr[ROOT].ob_width;
	tr[ROOT].ob_y = oby + tree[obj].ob_height;

	for (n = 0; n < maxn; n++)
	{
		tr[n + 1].ob_state &= ~SELECTED;
		tr[n + 1].ob_flags |= SELECTABLE | TOUCHEXIT; 

		idx_ublk[n].ub_parm = 0x10000L | (n+1);
		idx_ublk[n].ub_code = paint_index;
		ppd_userdef(tr, n+1, &idx_ublk[n]);
	}
	tr[*idx].ob_state |= SELECTED;

	form_dial(0,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (zoom) form_dial(1,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	 
	objc_draw(tr, ROOT, MAX_DEPTH, tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);
	
	n = (c1_form_do(tr, 0, &msg_stop)) & 0x7FFF;

	if (zoom) form_dial(2,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);


	form_dial(3,obx,oby,tree[obj].ob_width,tree[obj].ob_height, 
	            tr[ROOT].ob_x, tr[ROOT].ob_y, tr[ROOT].ob_width, tr[ROOT].ob_height);

	if (n > 0) *idx = n;

	return msg_stop;
}




static VOID userdef(LPTREE tree)
{
	LPTEDI tedi;
	
	pre_ublk[0].ub_code = paint_colour;
	pre_ublk[1].ub_code = paint_colour;
	pre_ublk[2].ub_code = paint_style;
	pre_ublk[3].ub_code = paint_index;
	pre_ublk[4].ub_code = paint_all;
	pre_ublk[5].ub_code = paint_id;
	pre_ublk[6].ub_code = paint_scheme;
	
	pre_ublk[0].ub_parm = cur_col[idno[cur_id]].fg;
	pre_ublk[1].ub_parm = cur_col[idno[cur_id]].bg;
	pre_ublk[2].ub_parm = cur_col[idno[cur_id]].fs;
	pre_ublk[3].ub_parm = cur_col[idno[cur_id]].fi;
	pre_ublk[4].ub_parm = (LONG)(ADDR(&cur_col[idno[cur_id]]));
	pre_ublk[5].ub_parm = cur_id;
	pre_ublk[6].ub_parm = curcol;

	tedi = (LPTEDI)(tree[SNAME].ob_spec);
	tedi->te_ptext = ADDR(csid[curcol]);
}


static VOID refresh(LPTREE tree)
{
	userdef(tree);
	
	if (cur_col[idno[cur_id]].fs < 2) 
		{
	    tree[COMBO4B].ob_state |= DISABLED;
	    tree[COMBO4A].ob_state |= DISABLED;
		}
	else 
		{
		tree[COMBO4B].ob_state &= ~DISABLED;
		tree[COMBO4A].ob_state &= ~DISABLED;
		}
	objc_draw(tree, COMBO4B, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, COMBO1A, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, COMBO2A, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, COMBO3A, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, COMBO4A, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, COMBO5A, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, PREVIEW, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
	objc_draw(tree, SNAME,   1, tree[ROOT].ob_x, tree[ROOT].ob_y,
						        tree[ROOT].ob_width, tree[ROOT].ob_height);
}



WORD c_form_do(LPTREE tree, WORD start_fld)
{
	WORD msg_stop = 0;
	WORD obj = start_fld;
	WORD editing = 1;

	if (ReadINI()) return -1;
	cur_col = def_col + 16*curcol;

	set_colours();
	paint_desk();
	userdef(tree);

	ppd_userdef(tree, COMBO1A, &pre_ublk[0]);
	ppd_userdef(tree, COMBO2A, &pre_ublk[1]);
	ppd_userdef(tree, COMBO3A, &pre_ublk[2]);
	ppd_userdef(tree, COMBO4A, &pre_ublk[3]);
	ppd_userdef(tree, PREVIEW, &pre_ublk[4]);
	ppd_userdef(tree, COMBO5A, &pre_ublk[5]);
	
	
	while (editing)
	{
		obj = (c1_form_do(tree, start_fld, &msg_stop) & 0x7FFF);
		if (msg_stop) return 1;
		if (!obj) continue;	// Click outside window
		
		switch(obj)
		{
			case BTNOK:
			WriteINI();
			// Fall through to...
			
			case BTNCLS:
			editing = 0;
			tree[obj].ob_state &= ~SELECTED;
			gl_rmsg[0] = WM_CLOSED;
			gl_rmsg[4] = hello_whndl;
			hndl_mesag();
			
			return TRUE;

			case BTNAPPLY:

			set_colours();
			tree[obj].ob_state &= ~SELECTED;
			paint_desk();
			objc_draw(tree, ROOT, MAX_DEPTH, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			break;
								    
			
			case COMBO1B:
			msg_stop = get_colour(&cur_col[idno[cur_id]].fg, tree, obj);
			tree[obj].ob_state &= ~SELECTED;
			if (msg_stop) return 1;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			refresh(tree);
			break;
			
			case COMBO2B:
			msg_stop = get_colour(&cur_col[idno[cur_id]].bg, tree, obj);
			tree[obj].ob_state &= ~SELECTED;
			if (msg_stop) return 1;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			refresh(tree);
			break;			
			
			case COMBO3B:
			msg_stop = get_style(&cur_col[idno[cur_id]].fs, tree, obj);
			tree[obj].ob_state &= ~SELECTED;
			if (msg_stop) return 1;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			refresh(tree);
			break;			

			case COMBO4B:
			msg_stop = get_index(&cur_col[idno[cur_id]].fi, tree, obj);
			tree[obj].ob_state &= ~SELECTED;
			if (msg_stop) return 1;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			refresh(tree);
			break;			

			case COMBO5B:
			msg_stop = get_id(&cur_id, tree, obj);
			tree[obj].ob_state &= ~SELECTED;
			if (msg_stop) return 1;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			refresh(tree);
			break;			

			case COMBO6B:
			msg_stop = get_scheme(&curcol, tree, obj);
			cur_col = def_col + 16*curcol;
			tree[obj].ob_state &= ~SELECTED;
			if (msg_stop) return 1;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			refresh(tree);
			break;			
			
			default:
			tree[obj].ob_state &= ~SELECTED;
			objc_draw(tree, obj, 1, tree[ROOT].ob_x, tree[ROOT].ob_y,
								    tree[ROOT].ob_width, tree[ROOT].ob_height);
			break;
		}
	}
	return msg_stop;
}
